<html>
<head>
<title>OgreBillboardChain.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreBillboardChain.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreBillboardChain_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Thanks to Vincent Cantin (karmaGfa) for the original implementation of this</span>
<a name="l00030"></a>00030 <span class="comment">// class, although it has now been mostly rewritten</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifndef _BillboardChain_H__</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#define _BillboardChain_H__</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreResourceGroupManager_8h.html">OgreResourceGroupManager.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre {
<a name="l00042"></a>00042 
<a name="l00076"></a><a class="code" href="classOgre_1_1BillboardChain.html">00076</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BillboardChain.html" title="Allows the rendering of a chain of connected billboards.">BillboardChain</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="keyword">public</span>:
<a name="l00080"></a>00080 
<a name="l00083"></a><a class="code" href="classOgre_1_1BillboardChain_1_1Element.html">00083</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html" title="Contains the data of an element of the BillboardChain.">Element</a>
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085 
<a name="l00086"></a>00086         <span class="keyword">public</span>:
<a name="l00087"></a>00087 
<a name="l00088"></a>00088             <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html" title="Contains the data of an element of the BillboardChain.">Element</a>();
<a name="l00089"></a>00089 
<a name="l00090"></a>00090             <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html" title="Contains the data of an element of the BillboardChain.">Element</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp;position,
<a name="l00091"></a>00091                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width,
<a name="l00092"></a>00092                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> texCoord,
<a name="l00093"></a>00093                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;colour,
<a name="l00094"></a>00094                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> &amp;orientation);
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#a8ba26812cafc456d1ffcdafba1edc4c7">00096</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#a8ba26812cafc456d1ffcdafba1edc4c7">position</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#a12ba93bd71664de7567e0f8e84cd3691">00097</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#a12ba93bd71664de7567e0f8e84cd3691">width</a>;
<a name="l00099"></a><a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#adfcbe79d8b6bd60c8ea91c2c75f92f46">00099</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#adfcbe79d8b6bd60c8ea91c2c75f92f46" title="U or V texture coord depending on options.">texCoord</a>;
<a name="l00100"></a><a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#aca293130c8752d30fc6a7bee3252fc36">00100</a>             <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#aca293130c8752d30fc6a7bee3252fc36">colour</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102             <span class="comment">//Only used when mFaceCamera == false</span>
<a name="l00103"></a><a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#a511a534a85e4accfbbdcb34dc4bcd66c">00103</a>             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1BillboardChain_1_1Element.html#a511a534a85e4accfbbdcb34dc4bcd66c">orientation</a>;
<a name="l00104"></a>00104         };
<a name="l00105"></a><a class="code" href="classOgre_1_1BillboardChain.html#ae550e95f48e0d9fe69f8b7a04cf8e790">00105</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Element&gt;::type</a> <a class="code" href="classOgre_1_1BillboardChain.html#ae550e95f48e0d9fe69f8b7a04cf8e790">ElementList</a>;
<a name="l00106"></a>00106 
<a name="l00115"></a>00115         <a class="code" href="classOgre_1_1BillboardChain.html" title="Allows the rendering of a chain of connected billboards.">BillboardChain</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">size_t</span> maxElements = 20, <span class="keywordtype">size_t</span> numberOfChains = 1, 
<a name="l00116"></a>00116             <span class="keywordtype">bool</span> useTextureCoords = <span class="keyword">true</span>, <span class="keywordtype">bool</span> useColours = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dynamic = <span class="keyword">true</span>);
<a name="l00118"></a>00118         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1BillboardChain.html" title="Allows the rendering of a chain of connected billboards.">BillboardChain</a>();
<a name="l00119"></a>00119 
<a name="l00122"></a>00122         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMaxChainElements(<span class="keywordtype">size_t</span> maxElements);
<a name="l00125"></a><a class="code" href="classOgre_1_1BillboardChain.html#a14f08e079d9475d25570dfb3e9e34324">00125</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1BillboardChain.html#a14f08e079d9475d25570dfb3e9e34324" title="Get the maximum number of chain elements per chain.">getMaxChainElements</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaxElementsPerChain; }
<a name="l00129"></a>00129         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setNumberOfChains(<span class="keywordtype">size_t</span> numChains);
<a name="l00133"></a><a class="code" href="classOgre_1_1BillboardChain.html#a0a88057e847d5dc4357ace0dac46365f">00133</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1BillboardChain.html#a0a88057e847d5dc4357ace0dac46365f" title="Get the number of chain segments (this class can render multiple chains at once using the same materi...">getNumberOfChains</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mChainCount; }
<a name="l00134"></a>00134 
<a name="l00141"></a>00141         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setUseTextureCoords(<span class="keywordtype">bool</span> use);
<a name="l00145"></a><a class="code" href="classOgre_1_1BillboardChain.html#a1a376259d9f5473200f0a30f56758bcb">00145</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#a1a376259d9f5473200f0a30f56758bcb" title="Gets whether texture coordinate information should be included in the final buffers generated...">getUseTextureCoords</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseTexCoords; }
<a name="l00146"></a>00146 
<a name="l00150"></a><a class="code" href="classOgre_1_1BillboardChain.html#a92be262f8957455b6fc2adfe9904d0ee">00150</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1BillboardChain.html#a92be262f8957455b6fc2adfe9904d0ee" title="The direction in which texture coordinates from elements of the chain are used.">TexCoordDirection</a>
<a name="l00151"></a>00151         {
<a name="l00153"></a><a class="code" href="classOgre_1_1BillboardChain.html#a92be262f8957455b6fc2adfe9904d0eeab1390d0782b4780e43953c2b166b9cdc">00153</a>             <a class="code" href="classOgre_1_1BillboardChain.html#a92be262f8957455b6fc2adfe9904d0eeab1390d0782b4780e43953c2b166b9cdc" title="Tex coord in elements is treated as the &#39;u&#39; texture coordinate.">TCD_U</a>,
<a name="l00155"></a><a class="code" href="classOgre_1_1BillboardChain.html#a92be262f8957455b6fc2adfe9904d0eea8053985a9b153f4dea4ea70db8536782">00155</a>             TCD_V
<a name="l00156"></a>00156         };
<a name="l00161"></a>00161         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTextureCoordDirection(TexCoordDirection dir);
<a name="l00165"></a><a class="code" href="classOgre_1_1BillboardChain.html#aae77ad0e6c295ecf6ac088b1a9f2ce8c">00165</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1BillboardChain.html#a92be262f8957455b6fc2adfe9904d0ee" title="The direction in which texture coordinates from elements of the chain are used.">TexCoordDirection</a> <a class="code" href="classOgre_1_1BillboardChain.html#aae77ad0e6c295ecf6ac088b1a9f2ce8c" title="Gets the direction in which texture coords specified on each element are deemed to run...">getTextureCoordDirection</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mTexCoordDir; }
<a name="l00166"></a>00166 
<a name="l00172"></a>00172         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOtherTextureCoordRange(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> start, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> end);
<a name="l00176"></a><a class="code" href="classOgre_1_1BillboardChain.html#ab615dc1c8dc72cb42cfd8641206a8ce8">00176</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* <a class="code" href="classOgre_1_1BillboardChain.html#ab615dc1c8dc72cb42cfd8641206a8ce8" title="Get the range of the texture coordinates generated across the width of the chain elements.">getOtherTextureCoordRange</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOtherTexCoordRange; }
<a name="l00177"></a>00177 
<a name="l00184"></a>00184         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setUseVertexColours(<span class="keywordtype">bool</span> use);
<a name="l00188"></a><a class="code" href="classOgre_1_1BillboardChain.html#ab7d11dc2ff50c28b7b7d808dea5f577b">00188</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#ab7d11dc2ff50c28b7b7d808dea5f577b" title="Gets whether vertex colour information should be included in the final buffers generated.">getUseVertexColours</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseVertexColour; }
<a name="l00189"></a>00189 
<a name="l00193"></a>00193         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDynamic(<span class="keywordtype">bool</span> dyn);
<a name="l00194"></a>00194 
<a name="l00198"></a><a class="code" href="classOgre_1_1BillboardChain.html#a41bde8d15c26fe6f9b9b3518f96e333c">00198</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#a41bde8d15c26fe6f9b9b3518f96e333c" title="Gets whether or not the buffers created for this object are suitable for dynamic alteration.">getDynamic</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDynamic; }
<a name="l00199"></a>00199         
<a name="l00208"></a>00208         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addChainElement(<span class="keywordtype">size_t</span> chainIndex, 
<a name="l00209"></a>00209             <span class="keyword">const</span> Element&amp; billboardChainElement);
<a name="l00213"></a>00213         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeChainElement(<span class="keywordtype">size_t</span> chainIndex);
<a name="l00220"></a>00220         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateChainElement(<span class="keywordtype">size_t</span> chainIndex, <span class="keywordtype">size_t</span> elementIndex, 
<a name="l00221"></a>00221             <span class="keyword">const</span> Element&amp; billboardChainElement);
<a name="l00227"></a>00227         <span class="keyword">virtual</span> <span class="keyword">const</span> Element&amp; getChainElement(<span class="keywordtype">size_t</span> chainIndex, <span class="keywordtype">size_t</span> elementIndex) <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00230"></a>00230         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getNumChainElements(<span class="keywordtype">size_t</span> chainIndex) <span class="keyword">const</span>;
<a name="l00231"></a>00231 
<a name="l00233"></a>00233         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearChain(<span class="keywordtype">size_t</span> chainIndex);
<a name="l00235"></a>00235         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearAllChains(<span class="keywordtype">void</span>);
<a name="l00236"></a>00236 
<a name="l00253"></a>00253         <span class="keywordtype">void</span> setFaceCamera( <span class="keywordtype">bool</span> faceCamera, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp;normalVector=<a class="code" href="classOgre_1_1Vector3.html#a0c21d1f120c5eab83aa966e5de1df311">Vector3::UNIT_X</a> );
<a name="l00254"></a>00254 
<a name="l00256"></a><a class="code" href="classOgre_1_1BillboardChain.html#afd16a80211461e6586e7ee00abd91975">00256</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1BillboardChain.html#afd16a80211461e6586e7ee00abd91975" title="Get the material name in use.">getMaterialName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaterialName; }
<a name="l00258"></a>00258         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMaterialName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a70da3137e703c147b98fbfbbebfbf023" title="Special resource group name which causes resource group to be automatically determined based on searc...">ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME</a> );
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261         <span class="comment">// Overridden members follow</span>
<a name="l00262"></a>00262         <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00263"></a>00263         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00264"></a>00264         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00265"></a>00265         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00266"></a>00266         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00267"></a>00267         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00268"></a>00268         <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a> *);
<a name="l00269"></a>00269         <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> &amp;);
<a name="l00270"></a>00270         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> *) <span class="keyword">const</span>;
<a name="l00271"></a>00271         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00273"></a>00273         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00274"></a>00274             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278     <span class="keyword">protected</span>:
<a name="l00279"></a>00279 
<a name="l00281"></a><a class="code" href="classOgre_1_1BillboardChain.html#aefe909743fa27074b38934765d4aaa4d">00281</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1BillboardChain.html#aefe909743fa27074b38934765d4aaa4d" title="Maximum length of each chain.">mMaxElementsPerChain</a>;
<a name="l00283"></a><a class="code" href="classOgre_1_1BillboardChain.html#ad412200ea57abd9d66d1ad53d3489971">00283</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1BillboardChain.html#ad412200ea57abd9d66d1ad53d3489971" title="Number of chains.">mChainCount</a>;
<a name="l00285"></a><a class="code" href="classOgre_1_1BillboardChain.html#a6b1da27f647afa420938a085f785fbd2">00285</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#a6b1da27f647afa420938a085f785fbd2" title="Use texture coords?">mUseTexCoords</a>;
<a name="l00287"></a><a class="code" href="classOgre_1_1BillboardChain.html#a57a517fd9daca4d840d3b390ccafada3">00287</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#a57a517fd9daca4d840d3b390ccafada3" title="Use vertex colour?">mUseVertexColour</a>;
<a name="l00289"></a><a class="code" href="classOgre_1_1BillboardChain.html#aea966c7849e7c19996ed5487668b41a7">00289</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#aea966c7849e7c19996ed5487668b41a7" title="Dynamic use?">mDynamic</a>;
<a name="l00291"></a><a class="code" href="classOgre_1_1BillboardChain.html#af915d8a6b50b4fb60ef01ad2bc015546">00291</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="classOgre_1_1BillboardChain.html#af915d8a6b50b4fb60ef01ad2bc015546" title="Vertex data.">mVertexData</a>;
<a name="l00293"></a><a class="code" href="classOgre_1_1BillboardChain.html#aa87a666d5ceaa7ed1c3d86fd32c6eb3f">00293</a>         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* <a class="code" href="classOgre_1_1BillboardChain.html#aa87a666d5ceaa7ed1c3d86fd32c6eb3f" title="Index data (to allow multiple unconnected chains)">mIndexData</a>;
<a name="l00295"></a><a class="code" href="classOgre_1_1BillboardChain.html#aae629740256ea4e8d8da226775ae1659">00295</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#aae629740256ea4e8d8da226775ae1659" title="Is the vertex declaration dirty?">mVertexDeclDirty</a>;
<a name="l00297"></a><a class="code" href="classOgre_1_1BillboardChain.html#aec664880b12b4a7e5ad01e7a6e3b9bd2">00297</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#aec664880b12b4a7e5ad01e7a6e3b9bd2" title="Do the buffers need recreating?">mBuffersNeedRecreating</a>;
<a name="l00299"></a><a class="code" href="classOgre_1_1BillboardChain.html#a3f890b4815dd3d41d715e0f2c76250a1">00299</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#a3f890b4815dd3d41d715e0f2c76250a1" title="Do the bounds need redefining?">mBoundsDirty</a>;
<a name="l00301"></a><a class="code" href="classOgre_1_1BillboardChain.html#a873172894953a295eba352135d4c36b3">00301</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#a873172894953a295eba352135d4c36b3" title="Is the index buffer dirty?">mIndexContentDirty</a>;
<a name="l00303"></a><a class="code" href="classOgre_1_1BillboardChain.html#aab0741d3d30f1b2bf98fbd2cae30f6c7">00303</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1BillboardChain.html#aab0741d3d30f1b2bf98fbd2cae30f6c7" title="AABB.">mAABB</a>;
<a name="l00305"></a><a class="code" href="classOgre_1_1BillboardChain.html#ae4f95218c50448ce4c6e1e66c9e73fc5">00305</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1BillboardChain.html#ae4f95218c50448ce4c6e1e66c9e73fc5" title="Bounding radius.">mRadius</a>;
<a name="l00307"></a><a class="code" href="classOgre_1_1BillboardChain.html#a67e082079a33ca93998f52c00df1f5a2">00307</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1BillboardChain.html#a67e082079a33ca93998f52c00df1f5a2" title="Material.">mMaterialName</a>;
<a name="l00308"></a><a class="code" href="classOgre_1_1BillboardChain.html#a15419eb83c937d210d9382dbed68affa">00308</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1BillboardChain.html#a15419eb83c937d210d9382dbed68affa">mMaterial</a>;
<a name="l00310"></a><a class="code" href="classOgre_1_1BillboardChain.html#a18051c037fe1a35ce5003c04220598f7">00310</a>         <a class="code" href="classOgre_1_1BillboardChain.html#a92be262f8957455b6fc2adfe9904d0ee" title="The direction in which texture coordinates from elements of the chain are used.">TexCoordDirection</a> <a class="code" href="classOgre_1_1BillboardChain.html#a18051c037fe1a35ce5003c04220598f7" title="Texture coord direction.">mTexCoordDir</a>;
<a name="l00312"></a><a class="code" href="classOgre_1_1BillboardChain.html#afc825019160a0ddc9cf2653692eab35e">00312</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mOtherTexCoordRange[2];
<a name="l00314"></a><a class="code" href="classOgre_1_1BillboardChain.html#a39cd29f1667fe328192a2c16a2032e1e">00314</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1BillboardChain.html#a39cd29f1667fe328192a2c16a2032e1e" title="When true, the billboards always face the camera.">mFaceCamera</a>;
<a name="l00318"></a><a class="code" href="classOgre_1_1BillboardChain.html#a5d84c89c56a0c5a6bbe7823801daf5d0">00318</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1BillboardChain.html#a5d84c89c56a0c5a6bbe7823801daf5d0" title="Used when mFaceCamera == false; determines the billboard&#39;s &quot;normal&quot;.">mNormalBase</a>;
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00322"></a><a class="code" href="classOgre_1_1BillboardChain.html#a325fc4495bd2c35da4a4d771611bcd44">00322</a>         <a class="code" href="classOgre_1_1BillboardChain.html#ae550e95f48e0d9fe69f8b7a04cf8e790">ElementList</a> <a class="code" href="classOgre_1_1BillboardChain.html#a325fc4495bd2c35da4a4d771611bcd44" title="The list holding the chain elements.">mChainElementList</a>;
<a name="l00323"></a>00323 
<a name="l00331"></a><a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html">00331</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html" title="Simple struct defining a chain segment by referencing a subset of the preallocated buffer (which will...">ChainSegment</a>
<a name="l00332"></a>00332         {
<a name="l00334"></a><a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html#a2c6adff0f71d170a1d0c3ca336f44768">00334</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html#a2c6adff0f71d170a1d0c3ca336f44768" title="The start of this chains subset of the buffer.">start</a>;
<a name="l00336"></a><a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html#a2297794c9d5c82455d6f0ebba8db1b37">00336</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html#a2297794c9d5c82455d6f0ebba8db1b37" title="The &#39;head&#39; of the chain, relative to start.">head</a>;
<a name="l00338"></a><a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html#a7e756025f58f6c7e6f6d0f63afe57e6c">00338</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1BillboardChain_1_1ChainSegment.html#a7e756025f58f6c7e6f6d0f63afe57e6c" title="The &#39;tail&#39; of the chain, relative to start.">tail</a>;
<a name="l00339"></a>00339         };
<a name="l00340"></a><a class="code" href="classOgre_1_1BillboardChain.html#a8a4f66ff061e1ecfa0dba21232fdcff9">00340</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ChainSegment&gt;::type</a> <a class="code" href="classOgre_1_1BillboardChain.html#a8a4f66ff061e1ecfa0dba21232fdcff9">ChainSegmentList</a>;
<a name="l00341"></a><a class="code" href="classOgre_1_1BillboardChain.html#af042e8c1dd576804ed9c64b9a2cdd7f2">00341</a>         <a class="code" href="classOgre_1_1BillboardChain.html#a8a4f66ff061e1ecfa0dba21232fdcff9">ChainSegmentList</a> <a class="code" href="classOgre_1_1BillboardChain.html#af042e8c1dd576804ed9c64b9a2cdd7f2">mChainSegmentList</a>;
<a name="l00342"></a>00342 
<a name="l00344"></a>00344         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setupChainContainers(<span class="keywordtype">void</span>);
<a name="l00346"></a>00346         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setupVertexDeclaration(<span class="keywordtype">void</span>);
<a name="l00347"></a>00347         <span class="comment">// Setup buffers</span>
<a name="l00348"></a>00348         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setupBuffers(<span class="keywordtype">void</span>);
<a name="l00350"></a>00350         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateVertexBuffer(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00352"></a>00352         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateIndexBuffer(<span class="keywordtype">void</span>);
<a name="l00353"></a>00353         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00354"></a>00354 
<a name="l00356"></a><a class="code" href="classOgre_1_1BillboardChain.html#aa2b8d91d34882251046dc02ae2500932">00356</a>         <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1BillboardChain.html#aa2b8d91d34882251046dc02ae2500932" title="Chain segment has no elements.">SEGMENT_EMPTY</a>;
<a name="l00357"></a>00357     };
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00361"></a><a class="code" href="classOgre_1_1BillboardChainFactory.html">00361</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BillboardChainFactory.html" title="Factory object for creating BillboardChain instances.">BillboardChainFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>
<a name="l00362"></a>00362     {
<a name="l00363"></a>00363     <span class="keyword">protected</span>:
<a name="l00364"></a>00364         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* createInstanceImpl( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params);
<a name="l00365"></a>00365     <span class="keyword">public</span>:
<a name="l00366"></a><a class="code" href="classOgre_1_1BillboardChainFactory.html#a2f92927f587d26d146244f0e4d79afc9">00366</a>         <a class="code" href="classOgre_1_1BillboardChainFactory.html#a2f92927f587d26d146244f0e4d79afc9">BillboardChainFactory</a>() {}
<a name="l00367"></a><a class="code" href="classOgre_1_1BillboardChainFactory.html#aecdd653fb996d9d4514d215b7f815bbc">00367</a>         <a class="code" href="classOgre_1_1BillboardChainFactory.html#aecdd653fb996d9d4514d215b7f815bbc">~BillboardChainFactory</a>() {}
<a name="l00368"></a>00368 
<a name="l00369"></a><a class="code" href="classOgre_1_1BillboardChainFactory.html#a2658ad034ae75ff78a19933bd2df89af">00369</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1BillboardChainFactory.html#a2658ad034ae75ff78a19933bd2df89af">FACTORY_TYPE_NAME</a>;
<a name="l00370"></a>00370 
<a name="l00371"></a>00371         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00372"></a>00372         <span class="keywordtype">void</span> destroyInstance( <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj);  
<a name="l00373"></a>00373 
<a name="l00374"></a>00374     };
<a name="l00375"></a>00375 
<a name="l00379"></a>00379 } <span class="comment">// namespace</span>
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 <span class="preprocessor">#endif</span>
<a name="l00382"></a>00382 <span class="preprocessor"></span>
<a name="l00383"></a>00383 
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
